# Test run with no optional dependencies installed, to help
# detect any accidental dependencies.

name: Core tests

on:
  pull_request

jobs:
  core:
    strategy:
      matrix:
        os: [ubuntu-latest, windows-latest]
        python-version: ['3.7', '3.8', '3.9', '3.10', '3.11', '3.12']

    runs-on: ${{ matrix.os }}

    steps:
    - uses: actions/checkout@v4
    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}
        allow-prereleases: true
    - name: Install local package
      run: |
        # Uninstall setuptools so that the tests will catch any accidental
        # dependence of the Traits source on setuptools. Note that in future
        # setuptools may not exist in a newly-created venv
        # https://github.com/python/cpython/issues/95299
        python -m pip uninstall -y setuptools
        python -m pip install .
        python -m pip list
    - name: Test Traits package
      run: |
        mkdir testdir
        cd testdir
        python -m unittest discover -v traits
